/* LICENSE BLOCK
Part of mde: a Modular D game-oriented Engine
Copyright © 2007-2008 Diggory Hardy

This program is free software: you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation, either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/// Sets up freetype (in a basic way).
module mde.ft.init;

import derelict.freetype.ft;

import tango.stdc.stringz;
import tango.util.log.Log : Log, Logger;

private Logger logger;
static this () {
    logger = Log.getLogger ("mde.ft.init");
}

FT_Library  library;
FT_Face     face;

// FIXME: use a different exception
const PATH = "/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf";
void initFreeType () {
    if (FT_Init_FreeType (&library))
        throw new Exception ("error initialising the FreeType library");
        
    if (FT_New_Face (library, toStringz(PATH), 0, &face))
        throw new Exception ("Unable to read font: "~PATH);
        
    if (FT_Set_Pixel_Sizes (face, 32,32))
        throw new Exception ("Unable to set pixel size");
}

void cleanupFreeType () {
    FT_Done_Face (face);
    FT_Done_FreeType (library);
}
